/* SystemPolls v1.0 */
/* Руссифицировано */

#include <amxmodx>

new configini[81], cvarFreqPoll, cvarTimePoll, poll[21][8][81], vote_amount[21][8][5], 
line_pool[21], polls_menu[4][530], polls_keys[4], page[33], polls_amount, poll_number,
polls_menu_title[4][11] = {0, "PollsMenuA", "PollsMenuB", "PollsMenuC"}, page_item[3] = {0, 7, 14};

public plugin_init() {
	register_plugin("SystemPolls", "1.0", "ZETA [M|E|N]");
	register_clcmd("say /polls", "show_polls_menu0", ADMIN_ALL, "- показывает меню опросов.");
	register_cvar("sp_freq_poll", "7");
	register_cvar("sp_time_poll", "9");
	register_menucmd(register_menuid("1"), 513, "poll_menu_handler");
	register_menucmd(register_menuid("2"), 515, "poll_menu_handler");
	register_menucmd(register_menuid("3"), 519, "poll_menu_handler");
	register_menucmd(register_menuid("4"), 527, "poll_menu_handler");
	register_menucmd(register_menuid("5"), 543, "poll_menu_handler");
	register_menucmd(register_menuid("6"), 575, "poll_menu_handler");
	register_menucmd(register_menuid("7"), 639, "poll_menu_handler");
	register_menucmd(register_menuid("PollResult"), 768, "poll_result_menu_handler");
}

public plugin_cfg() {
	get_localinfo("amxx_configsdir", configini, charsmax(configini));
	format(configini, charsmax(configini), "%s/SystemPolls.ini", configini);
	
	if(!file_exists(configini)) 
		server_print("Error: SystemPolls: The configuration file is not found!");
		
	new string[441], command[36], line, num;
	for(line = 0; read_file(configini, line, string, charsmax(string), num); line++) {
		if(!(num > 0 && string[0] != ';'))
			continue;
			
		parse(string, command, charsmax(command));
		
		if(equal(command, "sp_poll")) {
			if(polls_amount > 20) {
				server_print("Error: SystemPolls: Polls amount is exceeded!");
				break;
			}
				
			line_pool[polls_amount] = line;
			
			parse(string, command, charsmax(command),
			poll[polls_amount][0], 80, vote_amount[polls_amount][0], 4,
			poll[polls_amount][1], 80, vote_amount[polls_amount][1], 4,
			poll[polls_amount][2], 80, vote_amount[polls_amount][2], 4,
			poll[polls_amount][3], 80, vote_amount[polls_amount][3], 4,
			poll[polls_amount][4], 80, vote_amount[polls_amount][4], 4,
			poll[polls_amount][5], 80, vote_amount[polls_amount][5], 4,
			poll[polls_amount][6], 80, vote_amount[polls_amount][6], 4,
			poll[polls_amount][7], 80, vote_amount[polls_amount][7], 4);
			polls_amount++
		} 
		else server_cmd("%s", string);
	}
	
	new pages_amount = floatround(float(polls_amount)/7, floatround_ceil);

	new menu[530], page, keys, len, i, k, n;
	for(page = 1; page <= pages_amount; page++) {
		len = format(menu, 529, "\yОпросы^n^n");
		keys = 0;
		
		switch(page) {
			case 1:{
				for(i = 0, k = 0, n = 1; i <= 6; i++, k++, n++) {
					if(!equali(poll[i][0], "")) {
						len += format(menu[len], 529 - len, "\r%d. \w%s^n", n, poll[i][0]);
						keys |= (1<<k);
					}
					else len += format(menu[len], 529 - len, "^n");
				}
				
				if(page == pages_amount) {
					len += format(menu[len], 529 - len, "^n^n^n\r0. \wВыход^n");
					keys |= (1<<9);
				}
				else {
					len += format(menu[len], 529 - len, "^n\r8. \wДальше^n\d9. Назад^n\r0. \wВыход^n");
					keys |= (1<<7)|(1<<9);
				}
			}
			case 2:{
				for(i = 7, k = 0, n = 1; i <= 13; i++, k++, n++) {
					if(!equali(poll[i][0], "")) {
						len += format(menu[len], 529 - len, "\r%d. \w%s^n", n, poll[i][0]);
						keys |= (1<<k);
					}
					else len += format(menu[len], 529 - len, "^n");
				}
				
				if(page == pages_amount) {
					len += format(menu[len], 529 - len, "^n\d8. Дальше^n\r9. \wНазад^n\r0. \wВыход^n");
					keys |= (1<<8)|(1<<9);
				}
				else {
					len += format(menu[len], 529 - len, "^n\r8. \wДальше^n\r9. \wНазад^n\r0. \wВыход^n");
					keys |= (1<<7)|(1<<8)|(1<<9);
				}
			}
			case 3:{
				for(i = 14, k = 0, n = 1; i <= 20; i++, k++, n++) {
					if(!equali(poll[i][0], "")) {
						len += format(menu[len], 529 - len, "\r%d. \w%s^n", n, poll[i][0]);
						keys |= (1<<k);
					}
					else len += format(menu[len], 529 - len, "^n");
				}
				
				len += format(menu[len], 529 - len, "^n\d8. Дальше^n\r9. \wНазад^n\r0. \wВыход^n");
				keys |= (1<<8)|(1<<9);
			}
		}
		copy(polls_menu[page], 529, menu);
		polls_keys[page] = keys;
		
		register_menucmd(register_menuid(polls_menu_title[page]), polls_keys[page], "polls_menu_handler");
	}
	
	set_task(1.0, "cvarsvalue");
}

public cvarsvalue() {
	cvarFreqPoll = get_cvar_num("sp_freq_poll");
	cvarTimePoll = get_cvar_num("sp_time_poll");
	
	set_task(float(cvarFreqPoll*60), "show_poll_menu", _, _, _, "b");
}

public show_polls_menu0(id) {
	page[id] = 1;
	show_polls_menu(id);
	return PLUGIN_HANDLED;
}

public show_polls_menu(id) {
	show_menu(id, polls_keys[page[id]], polls_menu[page[id]], -1, polls_menu_title[page[id]]);
	return PLUGIN_HANDLED;
}

public polls_menu_handler(id, item) {
	if(item == 9) 
		return PLUGIN_HANDLED;
			
	switch(item) {
		case 7:{
			page[id]++;
			show_polls_menu(id);
			return PLUGIN_HANDLED;
		}
		case 8:{
			page[id]--;
			show_polls_menu(id);
			return PLUGIN_HANDLED;
		}
		default:{
			poll_result(id, item + page_item[page[id]-1]);
			return PLUGIN_HANDLED;
		}
	}
	
	return PLUGIN_HANDLED;
}

public poll_result(id, number) {
	new menu[500], len, i;
	len = formatex(menu[len], 440 - len, "\y%s^n^n", poll[number][0]);
	
	for(i = 1; i <= 7; i++) {
		if(!equali(poll[number][i], "")) 
			len += formatex(menu[len], 440 - len, "\r%d. \w%s \y(%s)^n", i, poll[number][i], vote_amount[number][i])
		else 
			len += formatex(menu[len], 440 - len, "^n");
	}
	len += formatex(menu[len], 440 - len, "^n^n\r9. \wНазад^n\r0. \wВыход^n");

	show_menu(id, (1<<8)|(1<<9), menu, -1, "PollResult");
	return PLUGIN_HANDLED;
}

public poll_result_menu_handler(id, item) {
	switch(item) {
		case 8:{
			show_polls_menu(id);
			return PLUGIN_HANDLED;
		}
		case 9: return PLUGIN_HANDLED;
	}
	
	return PLUGIN_HANDLED;
}

public show_poll_menu() {
	poll_number = random_num(1, polls_amount-1);
	
	new menu[441], keys, len, i, k;
	len = formatex(menu[len], 440 - len, "\y%s^n^n", poll[poll_number][0]);
	
	for(i = 1, k = 0; i <= 7, k <= 6; i++, k++) {
		if(!equali(poll[poll_number][i], "")) {
			len += formatex(menu[len], 440 - len, "\r%d. \w%s^n", i, poll[poll_number][i]);
			keys |= (1<<k);
		}
		else len += formatex(menu[len], 440 - len, "^n");
	}
	
	len += formatex(menu[len], 440 - len, "^n^n\r0. \wВыход^n");
	keys |= (1<<9);
	
	new players[32], num;
	get_players(players, num);
	
	for(i = 0; i < num; i++) {
		show_menu(players[i], keys, menu, cvarTimePoll, vote_amount[poll_number][0]);
	}
	
	set_task(float(cvarTimePoll+2), "file_rewrite");
	return PLUGIN_HANDLED;
}

public poll_menu_handler(id, item) {
	if(item == 9)
		return PLUGIN_HANDLED;
		
	num_to_str(str_to_num(vote_amount[poll_number][item+1]) + 1, vote_amount[poll_number][item+1], 4);
	return PLUGIN_HANDLED;
}

public file_rewrite() {
	new addfile[401], len, i, k;
	len = format(addfile[len], charsmax(addfile) - len, "sp_poll ^"%s^" ^"%s^" ", poll[poll_number][0], vote_amount[poll_number][0]);
		
	for(k = 1; k <= 7; k++) {
		if(!equali(poll[i][k], "")) 
			len += format(addfile[len], charsmax(addfile) - len, "^"%s^" ^"%s^" ", poll[poll_number][k], vote_amount[poll_number][k]);
		else break;
	}
	
	write_file(configini, addfile, line_pool[poll_number]);
	return PLUGIN_HANDLED;
}

/* ICQ: 459353314 */
